from threading import Thread
import time
import datetime


class OperationLoop(Thread):
    def __init__(self, duration, ser, meas_loop, operation_event_finish, operation_event_start):
        super().__init__()
        self.dur = duration
        self.ser = ser
        self.meas_loop = meas_loop
        self.operation_event_finished = operation_event_finish
        self.operation_event_start = operation_event_start

    def run(self):
        
        self.ser.setOutputOn()
        self.operation_event_start.on_change()
        print("sys: stimulation start: " + str(datetime.datetime.now()))
        print("sys: stimulation (" + str(self.dur) + "s): ", end='')
        for i in range(self.dur):
            print("\r|", end='')
            time.sleep(1)
        print('')
        self.ser.setOutputOff()
        self.operation_event_finished.on_change()
        self.meas_loop.setDo(False)
        print("sys: stimulation stop: " + str(datetime.datetime.now()))
